-module(as).

- abstype state() = 
       {state, store:store(), 
	       gb_trees:tree(work:index(), true), 
               wl:wl(work:index(), work:work()),
	       gb_trees:tree(atom(), any())}.

- type term() = term:term().

- type context() = context:context().
-type list(X) = [X|list(X)] + [].

make_state() ->
    state().

insert(term(), term(), state()) ->
    state().

lookup(term(), context(), state()) ->
    {term(), state()}.

lookup(term(), state()) ->
    term().

lookup_cont(term(), fun(term(), state()) -> state() end, context(), state()) ->
    state().
			    

add_visited(work:work(), context(), state()) ->
    state().

get_work(state()) ->
    undefined + {ok, work:work(), state()}.

dict_put(atom(), term(), state()) ->
    state().

dict_get(atom(), state()) ->
    term().


%%% Make context table. For presentation.

make_context_table(state(), fun(tag:ip_name()) -> true + false end) ->
    gb_trees:tree(tag:ip_name(), {list(context()), list(tag:ip_name())}).

%%% Reporting errors

report(none + program:fnid(), report:message(), state()) ->
    state().

get_reports(state()) ->
    gb_trees:tree(report:message(), true).
