-module(cerl).

- type list(X) = [X | list(X)] + [].

- type bool() = true + false.

- abstype core_node() = c.
- public_type variable () = core_node().
- type 'fun'() = core_node().
- public_type clause() = core_node().
- type name() = int() + atom() + {atom(), int()}.
-type annotation() = any().

type (core_node()) -> 
    alias + apply + call + 'case' + 'catch' + clause 
	+ cons + 'fun' + 'let' + 'letrec' + literal 
	+ module + primop + 'receive' + seq + 'try' 
	+ tuple + values + var.

%%% Annotations

get_ann(core_node()) ->
    annotation().

concrete(core_node()) ->
    any().

%%% Module

module_name(core_node()) ->
    core_node().


values_es(core_node()) ->
    list(core_node()).

data_es(core_node()) ->
    list(core_node()).

data_arity(core_node()) ->
    int().

is_c_int(core_node()) ->
    bool().

%%% Char



%%% Atom

c_atom(name()) ->
    core_node().

is_c_atom(core_node()) ->
    bool().

atom_val(core_node()) ->
    atom().

atom_name(core_node()) -> 
    list(int()).

%%% Var

is_c_var(any()) ->
    bool().

var_name(variable()) ->
    name().

%%% Fun

fun_vars(core_node()) ->
    list(variable()).

fun_body(core_node()) ->
    core_node().

%%% Seq

seq_arg(core_node()) ->
    core_node().

seq_body(core_node()) ->
    core_node().

%%% Let

let_vars(core_node()) ->
    list(variable()).

let_arg(core_node()) ->
    core_node().

let_body(core_node()) ->
    core_node().

%%% Letrec

letrec_defs(core_node()) ->
    list({variable, 'fun'()}).

letrec_body(core_node()) ->
    core_node().

%%% Case

case_arg(core_node()) ->
    core_node().

case_clauses(core_node()) ->
    list(clause()).

%%% Clause

clause_guard(clause()) ->
    core_node().

clause_body(clause()) ->
    core_node().

%%% Receive

receive_timeout(core_node()) ->
    core_node().

receive_action(core_node()) ->
    core_node().

receive_clauses(core_node()) ->
    list(clause()).

%%% Apply

apply_op(core_node()) ->
    core_node().

apply_args(core_node()) ->
    list(core_node()).

%%% Call

call_module(core_node()) ->
    core_node().

call_name(core_node()) ->
    core_node().

call_args(core_node()) ->
    list(core_node()).


%%% Primop

primop_name(core_node()) ->
    core_node().

primop_args(core_node()) ->
    list(core_node()).

%%% Try

try_body(core_node()) ->
    core_node().

%%% Catch

catch_body(core_node()) ->
    core_node().
