-module(context).

-type list(X) = [X | list(X)] + [].

-type fnid() = program:fnid().

-abstype context() = {context, nil + fnid(), nil + fnid(), int()}.

-type context_table() = gb_trees:tree(int(), stack()).

-type context_index() = gb_trees:tree(stack(), int()).

-type stack() = list(fpos()).

-type fpos() = {fpos, program:fnid(), int()}.

-type weight_table() = gb_trees:tree(fnid(), int()).
-type strata_table() = gb_trees:tree(fnid(), fnid()).

% Process dictionary

+ dict = (max_contexts  -> int();
	  polyvariance  -> default + cfa + ddr_lim + ddr_sdr + ddr_sdr_lim;
	  cfa_k -> int();
	  context_table -> context_table();
	  context_index -> context_index();
	  weight_table  -> weight_table();
	  strata_table ->  strata_table()).

% The exported functions

init() ->
	true.

empty() ->
	context().

call(fnid(), int(), context()) ->
	context().

current_fnid(context()) ->
	fnid().

current_tyid(context()) ->
	fnid().

report_point(context()) ->
    {ok, fnid()} + not_found.

current_module(context()) ->
    atom().

caller(context()) ->
    fnid().

context_proper(context()) ->
    int().
