-module(env).

-abstype env(Key, Value) = gb_trees:tree(Key, Value).

-type list(X) = [X| list(X)] + [].

empty() ->
    env(none(), none()).

bind(Key, Val, env(Key, Val)) ->
    env(Key, Val).

bind_list(list(Key), list(Val), env(Key, Val)) ->
    env(Key, Val).

lookup(Key, env(Key, Val)) ->
    Val.

defined(Key, env(Key, Val)) ->
    true + false.
