-module(graph).

- abstype graph(Node) = gb_trees:tree(Node, gb_trees:tree(Node, int())).

- type list(X) = [X | list(X)] + [].

empty_graph() ->
    graph(none()).

new_node(Node, graph(Node)) ->
    graph(Node).

insert_son(Node, Node, graph(Node)) ->
    graph(Node).

insert_weighted_son(Node, Node, int(), graph(Node)) ->
    graph(Node).

node_list(graph(Node)) ->
    list(Node).

son_weight_list(Node, graph(Node)) -> 
   list({Node, int()}).

cycles(graph(Node)) ->
    list(list(Node)).

foldl(fun({Node, gb_trees:tree(Node, int())}, Data) ->
	      Data
      end,
      Data,
      graph(Node)) ->
    Data.


% To be removed.

% collect_cycle(list(Node), graph(Node), list(Node), gb_trees:tree(Node, true)) ->
%     {list(Node),  gb_trees:tree(Node, true)}.
