-module(program).

% The specification file is a bit of a mess. Will probably need to
% rewrite program.erl to get a more easily typable respresentation.


-abstype fnid() = {fnid, atom(), atom(), int()}.

-abstype tyid() = {tyid, atom(), atom(), int()}.

-abstype program() = {program, {gb_trees:tree(atom(), kinds:core_node()), 
				gb_trees:tree(atom(), true)},
		      gb_trees:tree(fnid(), kinds:core_node()),
		      gb_trees:tree(fnid() + spec:attribute(),
				    {spec, spec:spec(), spec:env()} + spec:attribute())}.

-type fnid_table() = gb_trees:tree(fnid(), kinds:core_node()).

-type list(X) = [X|list(X)] + [].
-type deepcharlist () = [] + [(int() + deepcharlist()) | deepcharlist()].

-type module() = atom().

-type extension() = erl + spec.

init() ->
    true.

load_mod(any(), atom()) ->
    true.

load_erl_module_list(list(atom()), any()) ->
    true.

try_module(atom(), erl + spec) ->
    true + false.

set_spec_mode_local(any()) ->
    true.

spec_mode(atom()) ->
    local + extern + unknown.

def(fnid()) ->
    kinds:fdef().

spec(fnid()) -> 
    {spec, spec:fspec(), spec:env()}.

attribute(atom(), fnid()) ->
    none + {value, spec:spec()}.

module_spec_list(any()) ->
    list(spec:fspec()).

program_fnid_table() ->
    fnid_table().

export_list(program()) ->
    list(fnid()).

typedef(tyid()) ->
    spec:typedef().

deid_type(fnid() + tyid()) ->
    fnid + tyid.

fnid_module(fnid()) ->
    atom().

fnid_name(fnid()) ->
    atom().

fnid_arity(fnid()) ->
    int().

make_fnid(atom(), atom(), int()) ->
    fnid().

show_fnid(fnid()) ->
    deepcharlist().

display_tyid(fnid()) ->
    {atom(), atom(), int()}.

tyid_module(tyid()) ->
    atom().


set_path(list(any())) ->
    true.
