-module(store).

% Exported types

-abstype store() = gb_trees:tree(term(), ip_data()).

% local types

-type ip_data() = 
    {ip_data, term(), list(term()), list(ap())}.

-type ap() = work:work().

-type term() = term:term().

-type wl() = wl:wl().

-type list(X) = [X | list(X)] + [].

-type work() = work:work().

empty_store() ->
    store().
    

insert(term(), term(), store()) ->
    {store(), list(work())}.

insert_term(term(), term(), store()) ->
    {store(), list(work())}.

multi_insert(list(term()), term(), list(work()), store()) ->
    {store(), list(work())}.

insert_list(term(), list(term()), store()) ->
    {store(), list(work())}.

install_link(term(), term(), store()) ->
    {store(), list(work())}.

depend(term(), ap(), store()) ->
    store().

lookup_ip_term(term(), store()) ->
    term().

%%% ip data

new_ip_data() ->
    ip_data().
    
%%%

make_context_table(store:store(), fun(tag:ip_name()) -> true + false end) ->
    gb_trees:tree(tag:ip_name(), {list(context:context()), list(tag:ip_name())}).
