-module(term).

- abstype term() = 
          {functor, functor_name(), list(term())}
	+ {universal}
	+ {parameter, atom()}
	+ {join, tree(term(), true)}
        + {trunc}
.

-public_type pos() = int().

- type functor_name() = 
 	  atomc
	+ {atoma, atom()}
        + nil
        + intc
        + {inta, int()}
        + floatc
        + cons.

-type tree(K, V) = gb_trees:tree(K, V).

-type list(X) = [X | list(X)] + [].

-type boolean() = true + false.

% Function specifications

is_atom(term()) ->
    true + false.

make_atom(atom()) ->
   term().

make_atom_any() ->
    term().

atom_val(term()) ->
    atom().

% term_atom_to_list(term()) ->
%     term().

make_int(int()) ->
    term().

make_int_any() ->
    term().

% int_val(term) ->
%     int().

make_float(float()) ->
    term().

make_float_any() ->
    term().

float_val(term) ->
    float().

make_cons(term(), term()) ->
    term().

make_nil() ->
    term().

make_string(_) ->
    term().

make_tuple(list(term())) ->
    term().

make_tuple_clean(term()) ->
    term().

make_vector(list(term())) ->
    term().

is_functor_term(term()) ->
    boolean().

apply_functor(functor_name(), list(term())) ->
    term().

term_functor(term()) ->
    functor_name().

term_functor_arg_list(term()) ->
    list(term()).

universal() ->
    term().

is_universal(term()) ->
    true + false.


%%% Fun

make_fun(context:context(), int(), int()) ->
    term().

fun_arity(term()) ->
    int().

fun_ap(term()) ->
    context:context().

fun_pos(term()) ->
    int().


%%% IP

make_ip(any(), context:context()) ->
    term().

%%% Pid

make_pid(any(), any(), context:context()) ->
    term().

make_pid(context:context()) ->
    term().

make_pid_with_mbox(term()) ->
    term().

pid_mbox(term()) ->
    term().
      
pid_location(term()) ->
    any().
    

% make_node(atom(), context:context()) ->
%     term().

% Parameter

parameter(atom()) ->
    term().

% is_parameter(term()) ->
%     boolean().
	
parameter_name(term()) ->
    any().

%%% Pattern

make_pattern_var(any()) ->
    term().

pattern_var_name(term()) ->
    any().

make_alias_pattern(any(), term()) ->
    term().

alias_pattern_var_name(term()) ->
    any().

alias_pattern_pattern(term()) ->
    term().


%%% Join

is_empty(term()) ->
    boolean().

join0() ->
    term().

join2(term(), term()) ->
    term().

join(list(term())) ->
    term().

join_arg_list(term()) ->
    list(term()).

included(term(), term()) ->
    boolean().

type(term()) -> constructor + 'fun' + ip + any + universal + parameter
    + join + pid + node.

%%% Unsafe

unsafe(term(), as:state()) ->
    term().

%%% Tag

term_tag(term()) -> ip + join + universal + functor + 'fun' + pid
			+ pattern_var + alias_pattern 
			+ parameter + trunc.

%%% Formal

is_formal(term()) ->
    true + false.


%%% Do all

do_all(term(), 
       fun(term(), as:state()) ->
	       as:state()
       end,
       context:context(),
       as:state()) ->
    as:state().

% 

make_numbered_ip(int()) ->
    term().

numbered_ip_number(term()) ->
    int().

trunc() ->
    term().
