-module(wl).

%-abstype wl() = {wl, int(), gb:tree(int(), work()), gb:tree(work(), int())}.
%
%-type work() = work:work().
%-type key() = work:index().
%
%-type list(X) = [X | list(X)] + [].
%
%empty() ->
%    wl().
%    
%insert(key(), work(), wl()) ->
%    wl().
%
%get_work(wl()) ->
%    {ok, work(), wl()} + undefined.
%    
%insert_list(list(key()), list(work()), wl()) ->
%    wl().

-abstype wl(K, W) = {wl, int(), gb_trees:tree(int(), {K, W}), gb_trees:tree(K, int())}.

-type work() = work:work().
-type key() = work:index().

-type list(X) = [X | list(X)] + [].

empty() ->
    wl(none(), none()).
    
insert(K, W, wl(K, W)) ->
    wl(K, W).

get_work(wl(K, W)) ->
    {ok, W, wl(K, W)} + undefined.
    
insert_list(list(K), list(W), wl(K, W)) ->
    wl(K, W).

