%%% File    : wl.erl
%%% Author  : Sven-Olof Nystr|m <svenolof@harpo.csd.uu.se>
%%% Purpose : 
%%% Created : 16 Feb 1999 by Sven-Olof Nystr|m <svenolof@harpo.csd.uu.se>

-module(wl).
-author('svenolof@harpo.csd.uu.se').

-export([empty/0, insert/3,  insert_list/3, get_work/1]).

empty() -> 
    {wl, 0, gb_trees:empty(), gb_trees:empty()}.

% insert(Work, WL) -> WL.

insert(Key, Work, {wl, Count, IndexToWork, WorkToIndex}) ->
    case gb_trees:is_defined(Key, WorkToIndex) of
	true ->
	    {wl, Count, IndexToWork, WorkToIndex};
	false  ->
	    {wl, Count +1, 
	     gb_trees:insert(Count, {Key, Work}, IndexToWork),
	     gb_trees:insert(Key, Count, WorkToIndex)}
    end.

insert_list([Key| KeyList], [Work | List], WL) ->
    insert_list(KeyList, List, insert(Key, Work, WL));
insert_list([], [], WL) ->
    WL.

% get_work(WL) -> {Work, WL}.

get_work({wl, Count, IndexToWork, WorkToIndex}) ->
    case gb_trees:is_empty(IndexToWork) of
	true ->
	    undefined;
	false ->
	    {_, {Key, Work}, ITW} = gb_trees:take_smallest(IndexToWork),
	    WTI = gb_trees:delete(Key, WorkToIndex),
	    {ok, Work, {wl, Count, ITW, WTI}}
    end.

