-module(gb_trees).

-abstype tree(K, V) = {int(), tree1(K, V)}.

-type tree1(K, V) = nil + {K, V, tree1(K, V), tree1(K, V)}.

-type list(X) = [X | list(X)] + [].

-type empty() = empty().

empty() ->
    tree(empty(), empty()).

is_empty(tree(K, V)) ->
	true + false.

lookup(K, tree(K, V)) ->
    none + {value, V}.

is_defined(K, tree(K, V)) ->
    true + false.

insert(K, V, tree(K, V)) ->
	tree(K, V).

update(K, V, tree(K, V)) ->
	tree(K, V).

enter(K, V, tree(K, V)) ->
	tree(K, V).
	
delete(K, tree(K, V)) ->
    tree(K, V).
       
size(tree(K, V)) ->
	int().

balance(tree(K, V)) ->
    tree(K, V).

to_list(tree(K,V)) ->
	list({K, V}).

take_smallest(tree(K, V)) ->
    {K, V, tree(K, V)}.


count(tree1(_, _)) ->
    {int(), int()}.






