-module(ordsets).

-type list(X) = [] + [X | list(X)].
-type boolean() = true + false.

%-abstype set(X) = list(X).
-public_type set(X) = list(X).

new() ->
    set(empty()).

is_set(any()) ->
    boolean().

size(set(_)) ->
    int().

to_list(set(X)) ->
    list(X).

from_list(list(X)) ->
    set(X).


is_element(X, set(X)) ->
    boolean().

add_element(X, set(X)) ->
    set(X).

del_element(X, set(X)) ->
    set(X).

union(set(X), set(X)) ->
    set(X).

intersection(set(X), set(X)) ->
    set(X).

subtract(set(X), set(X)) ->
    set(X).

is_subset(set(X), set(X)) ->
    boolean().

fold(fun(X, Acc) -> Acc end, Acc, set(X)) ->
    Acc.
	     

filter(fun (X) -> boolean() end, set(X)) ->
    set(X).

%% Depreciated??

list_to_set(list(X)) ->
    set(X).
